package cn.minestar.agriculture.service.impl;

import java.util.List;

import cn.minestar.agriculture.entity.WxMiniInfo;
import cn.minestar.agriculture.mapper.WxMiniInfoMapper;
import cn.minestar.agriculture.mapper.WxMiniLabelMapper;
import cn.minestar.agriculture.service.IWxMiniInfoService;
import cn.minestar.common.utils.DateUtils;
import cn.minestar.weixin.utils.ThirdSessionHolder;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 【请填写功能名称】Service业务层处理
 * 
 * @author www.minestar.cn/
 * @date 2021-08-10
 */
@Service
public class WxMiniInfoServiceImpl implements IWxMiniInfoService
{
    @Autowired
    private WxMiniInfoMapper wxMiniInfoMapper;
    @Autowired
    private WxMiniLabelMapper wxMiniLabelMapper;

    /**
     * 查询【请填写功能名称】
     * 
     * @param id 【请填写功能名称】ID
     * @return 【请填写功能名称】
     */
    @Override
    public WxMiniInfo selectWxMiniInfoById(Long id)
    {
        return wxMiniInfoMapper.selectWxMiniInfoById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     * 
     * @param wxMiniInfo 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<WxMiniInfo> selectWxMiniInfoList(WxMiniInfo wxMiniInfo)
    {
        return wxMiniInfoMapper.selectWxMiniInfoList(wxMiniInfo);
    }

    /**
     * 新增【请填写功能名称】
     * 
     * @param wxMiniInfo 【请填写功能名称】
     * @return 结果
     */
    @Override
    @Transactional
    public int insertWxMiniInfo(WxMiniInfo wxMiniInfo)
    {
        QueryWrapper queryWrapper = new QueryWrapper<>().eq("id",wxMiniInfo.getLabelId());
        Integer cnt =  wxMiniLabelMapper.selectCount(queryWrapper);
        if(null != cnt && cnt >0){
            String wxUserId = ThirdSessionHolder.getThirdSession().getWxUserId();
            wxMiniInfo.setReleaseTime(DateUtils.getNowDate());
            wxMiniInfo.setCreateBy(wxUserId);
            wxMiniInfo.setCreateTime(DateUtils.getNowDate());
          return   wxMiniInfoMapper.insertWxMiniInfo(wxMiniInfo);
        }
        return 0;
    }

    /**
     * 修改【请填写功能名称】
     * 
     * @param wxMiniInfo 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateWxMiniInfo(WxMiniInfo wxMiniInfo)
    {
        String wxUserId = ThirdSessionHolder.getThirdSession().getWxUserId();
        wxMiniInfo.setUpdateBy(wxUserId);
        wxMiniInfo.setUpdateTime(DateUtils.getNowDate());
        return wxMiniInfoMapper.updateWxMiniInfo(wxMiniInfo);
    }

    /**
     * 批量删除【请填写功能名称】
     * 
     * @param ids 需要删除的【请填写功能名称】ID
     * @return 结果
     */
    @Override
    public int deleteWxMiniInfoByIds(Long[] ids)
    {
        return wxMiniInfoMapper.deleteWxMiniInfoByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     * 
     * @param id 【请填写功能名称】ID
     * @return 结果
     */
    @Override
    public int deleteWxMiniInfoById(Long id)
    {
        return wxMiniInfoMapper.deleteWxMiniInfoById(id);
    }
}
